/**************************************************************************
 * PROGRAM:      TS-AIDS-NO.ox  
 *
 * PURPOSE:		  evaluate the calculation of the TS statistics for the situations 
 *				  mentioned in the paper by assuming Normal distribution for the errors
 *
 *						- independence x random intercept model
 * 						- independence x random slope model
 * 						- independence x random intercept-slope model
 *						- random slope model x random intercept-slope model
 *
 * AUTHOR:      Carine Savalli (carinesr@ime.usp.br)
 *				Francisco Jos de A. Cysneiros (cysneiros@de.ufpe.br).
 * 				
 *
 * LEGAL NOTE:   This program should NOT be used by or given to anyone 
 *               without explicit permission from the author. Also, the  
 *               author shall not be held liable for any damages that  
 *               possible errors or inaccuracies in the program may cause.
 *
 * VERSION:      1.0 (not ready for prime time yet, but almost...)
 *
 * DATE:         DECEMBER 15, 2004.
 * 
 * LAST REVISED: 
 */

#include <oxstd.h>
#include <oxprob.h>
#include <oxfloat.h>
#import  <solveqp>
main()
{
decl Ja,IDa,fga,C1b,C2b,IDb,Jib,fgb,kG,obse,paprec,pac,cd4,x3,x4,pred;
decl pacrep,pre,Jic,C1c,C2c,IDc,C3c,Jc,yia,predia,SIGa,yib,predib,SIGb,yic,predic,SIGc;
decl Stau1i,Ssigma2i,Ks2s2i,Kt1t1i,Kts2i,Kt1s2i,sigma,k,h,i,INVSIGa,ra,ua,va,INVSIGb,rb,ub;
decl vb,Jb,INVSIGc,rc,uc,vc,fgc,Stau1,Ssigma2,Ks2s2,Kt1t1,invKfifi,z,zia,zib,zic;
decl Stau2i,Kt2t2i,kt1s2,kts2i,zizia,zizib,Kt1s2,zizic,Stau2,Kt2s2,Kt1t2i,Kt2s2i,Kt2t2	;
decl Kt1t2,pred1,tau2,E,G,A,B,C,D,TS,TS1;
decl iret,mg,vg,ma,vbs,funr,x;

decl mx = loadmat("C:/carine/doutorado/artigo_tese/exemplos/aids/programas_corrigidos/predNO.txt");
obse=mx[][0];
pacrep=mx[][1];
pac=mx[][2];
cd4=mx[][3];
x3=mx[][4];
x4=mx[][5];
pred=mx[][6];
kG=0.9;
 Ja=0.0;
 IDa=1.0;
 Ja=1.0;
 fga=(1.0*(1.0+2.0))/4.0;
 Jib=<0.0;0.0>;
 C1b=<1,0.0>;
 C2b=<0.0,1.0>;
 IDb=C1b|C2b;
 Jib[0]=1.0;
 Jib[1]=1.0;
 Jb=Jib*Jib';
 fgb=(2.0*(2.0+2.0))/4.0;
 Jic=0.0;
 C1c=<1.0,0.0,0.0>;
 C2c=<0.0,1.0,0.0>;
 C3c=<0.0,0.0,1.0>;
 IDc=C1c|C2c|C3c;
 Jic=<0.0;0.0;0.0>;
 Jic[0]=1;
 Jic[1]=1;
 Jic[2]=1;
 Jc=Jic*Jic';
 fgc=(3.0*(3.0+2.0))/4.0;

/*
#################################################################################
#######  Calculation of TS statistic for testing one random effect in the########
#######  intercept against independence model                            ########
#################################################################################
*/

yia=zeros(1,1);
predia=zeros(1,1);
SIGa=zeros(1,1);

yib=zeros(2,1);
predib=zeros(2,1);
SIGb=zeros(2,2);

yic=zeros(3,1);
predic=zeros(3,1);
SIGc=zeros(3,3);

Stau1i=zeros(39,1);
Ssigma2i=zeros(39,1);
Ks2s2i=zeros(39,1);
Kt1t1i=zeros(39,1);
Kt1s2i=zeros(39,1);
sigma=45.8839;
k=0;
h=17;

for (i=0;i<39;++i) {
if (i < 3) {
SIGa=sigma^2.0;
INVSIGa=invert(SIGa);
yia[0]=cd4[i];
predia[0]=pred[i];
ra=yia-predia;

Stau1i[i]= (-(1.0/2.0)*sumr(diagonal(INVSIGa*Ja)))  +  ((1.0/2.0)*ra*INVSIGa*Ja*INVSIGa*ra);
Ssigma2i[i]=(-(1.0/2.0)*sumr(diagonal(INVSIGa*IDa))) +  ((1.0/2.0)*ra*INVSIGa*IDa*INVSIGa*ra) ;

Ks2s2i[i]=sumr(diagonal(INVSIGa*IDa))*sumr(diagonal(INVSIGa*IDa)) * (-1.0/4.0 + fga/(1.0*(1.0+2.0)))   + (2.0*fga/(1.0*(1.0+2.0)))*sumr(diagonal(INVSIGa*IDa*INVSIGa*IDa)) ;
Kt1t1i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*Ja))   * (-1.0/4.0 + fga/(1.0*(1.0+2.0)))   + (2.0*fga/(1.0*(1.0+2.0)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*Ja));
Kt1s2i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*IDa))  * (-1.0/4.0 + fga/(1.0*(1.0+2.0)))   + (2.0*fga/(1.0*(1.0+2.0)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*IDa))	;
}
else
if ((i>=3) && (i< 22)) {
SIGb=(sigma^2)*IDb;
INVSIGb=invert(SIGb);

yib[0]=cd4[i + k];
yib[1]=cd4[i + (k+1)];

predib[0]=pred[i + k];
predib[1]=pred[i + (k+1)];
rb=yib-predib;

Stau1i[i]= (-(1.0/2.0)*sumr(diagonal(INVSIGb*Jb)))  +  ((1.0/2.0)*rb'*INVSIGb*Jb*INVSIGb*rb);
Ssigma2i[i]=(-(1.0/2.0)*sumr(diagonal(INVSIGb*IDb))) +  ((1.0/2.0)*rb'*INVSIGb*IDb*INVSIGb*rb);
Ks2s2i[i]=sumr(diagonal(INVSIGb*IDb))*sumr(diagonal(INVSIGb*IDb))*(-1.0/4.0 + fgb/(2.0*(2.0+2.0))) + (2.0*fgb/(2.0*(2.0+2.0)))*sumr(diagonal(INVSIGb*IDb*INVSIGb*IDb));
Kt1t1i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*Jb))*(-1.0/4.0 + fgb/(2.0*(2.0+2.0)))   + (2.0*fgb/(2.0*(2.0+2.0)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*Jb));
Kt1s2i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*IDb))*(-1.0/4.0 + fgb/(2.0*(2.0+2.0)))  + (2.0*fgb/(2.0*(2.0+2.0)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*IDb));
k=k+1;
}
else	  
if ((i>=22) &&(i<=38)) {
h=h+2 ;
SIGc=(sigma^2)*IDc;
INVSIGc=invert(SIGc);

yic[0]=cd4[i+h];
yic[1]=cd4[i+(h+1)];
yic[2]=cd4[i+(h+2)];

predic[0]=pred[i+h];
predic[1]=pred[i+(h+1)];
predic[2]=pred[i+(h+2)];
rc=yic-predic;

Stau1i[i]= (-(1.0/2.0)*sumr(diagonal(INVSIGc*Jc)))  +  ((1.0/2.0)*rc'*INVSIGc*Jc*INVSIGc*rc);
Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGc*IDc))) +  ((1/2)*rc'*INVSIGc*IDc*INVSIGc*rc);
Ks2s2i[i]=sumr(diagonal(INVSIGc*IDc))*sumr(diagonal(INVSIGc*IDc))*(-1.0/4.0 + fgc/(3.0*(3.0+2.0))) + (2.0*fgc/(3.0*(3.0+2.0)))*sumr(diagonal(INVSIGc*IDc*INVSIGc*IDc));
Kt1t1i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*Jc))*(-1.0/4.0 + fgc/(3.0*(3.0+2.0)))   + (2.0*fgc/(3.0*(3.0+2.0)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*Jc));
Kt1s2i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*IDc))*(-1.0/4.0 + fgc/(3.0*(3.0+2.0)))  + (2.0*fgc/(3.0*(3.0+2.0)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*IDc));
}
}
Stau1=sumc(Stau1i);
Ssigma2=sumc(Ssigma2i);
Ks2s2 =sumc(Ks2s2i);
Kt1t1 =sumc(Kt1t1i);
Kt1s2=sumc(Kt1s2i);

invKfifi=1/(Kt1t1 - Kt1s2*(1/Ks2s2)*Kt1s2) ;
 
z=Stau1 - Kt1s2*(1/Ks2s2)*Ssigma2;
//TS=z'*invKfifi*z;
//println("TS (independence x random intercept model) = ", TS);

mg = 2*invKfifi;
vg = -2*invKfifi*z;
ma = unit(columns(invKfifi));
vbs = zeros(columns(invKfifi),1);
[iret,x] = SolveQP(mg, vg, ma, vbs, <>, <>, <>, <>);

//funr=(x'mg*x) / 2 + vg'x +z'*invKfifi*z;
//TS1=z'*invKfifi*z-funr;
TS1=-(x'mg*x)/2 - vg'x;
println("TS1 (independence x random intercept model) = ", TS1);

//    SolveQP(const G, const g, const A, const B, const C, const D, const vLo, const vHi); 
//
//    SolveQP solves the quadratic program
//    min f(x)=x'Gx/2 + x'g, subject to:
//    Ax >= b,
//    Cx = d,
//    xlo <= x <= xhi. 




/*
#################################################################################
#######  Calculation of TS statistic for testing one random effect in the########
#######  slope against independence model                                ########
#################################################################################
*/

yia=zeros(1,1);
predia=zeros(1,1);
zia=zeros(1,1);
SIGa=zeros(1,1);

yib=zeros(2,1);
predib=zeros(2,1);
zib=zeros(2,1);
SIGb=zeros(2,2);

yic=zeros(3,1);
predic=zeros(3,1);
zic=zeros(3,1);
SIGc=zeros(3,3);

Stau2i=zeros(39,1);
Ssigma2i=zeros(39,1);
Ks2s2i=zeros(39,1);
Kt2t2i=zeros(39,1);
Kt2s2i=zeros(39,1);
sigma=45.8839;
k=0;
h=17;

for (i=0;i<39;++i) {
if (i < 3) {
SIGa=sigma^2;
INVSIGa=invert(SIGa);
yia[0]=cd4[i];
predia[0]=pred[i] ;
zia[0]=x4[i];
zizia=zia*zia';
ra=yia-predia;

Stau2i[i]= (-(1.0/2.0)*sumr(diagonal(INVSIGa*zizia)))  +  ((1.0/2.0)*ra'*INVSIGa*zizia*INVSIGa*ra);
Ssigma2i[i]=(-(1.0/2.0)*sumr(diagonal(INVSIGa*IDa))) +  ((1.0/2.0)*ra'*INVSIGa*IDa*INVSIGa*ra);
Ks2s2i[i]=(INVSIGa*IDa)*(INVSIGa*IDa)*(-1/4 + fga/(1*(1+2))) + (2*fga/(1*(1+2)))*(INVSIGa*IDa*INVSIGa*IDa);
Kt2t2i[i]=(INVSIGa*zizia)*(INVSIGa*zizia)*(-1/4 + fga/(1*(1+2)))   + (2*fga/(1*(1+2)))*(INVSIGa*zizia*INVSIGa*zizia);
Kt2s2i[i]=(INVSIGa*zizia)*(INVSIGa*IDa)*(-1/4 + fga/(1*(1+2)))  + (2*fga/(1*(1+2)))*(INVSIGa*zizia*INVSIGa*IDa);
}
else
if ((i>=3) && (i< 22)) {
SIGb=(sigma^2)*IDb;
INVSIGb=invert(SIGb);

yib[0]=cd4[i + k];
yib[1]=cd4[i + (k+1)];

predib[0]=pred[i + k];
predib[1]=pred[i + (k+1)];

zib[0]=x4[i + k];
zib[1]=x4[i + (k+1)];
zizib=zib*zib';
rb=yib-predib;

Stau2i[i]= (-(1/2)*sumr(diagonal(INVSIGb*zizib)))  +  ((1/2)*rb'*INVSIGb*zizib*INVSIGb*rb);
Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGb*IDb))) +  ((1/2)*rb'*INVSIGb*IDb*INVSIGb*rb);
Ks2s2i[i]=sumr(diagonal(INVSIGb*IDb))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2))) + (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*IDb*INVSIGb*IDb));
Kt2t2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*zizib))*(-1/4 + fgb/(2*(2+2)))   + (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*zizib));
Kt2s2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))  + (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*IDb));
k=k+1;
}
else
if ((i>=22) && (i<=38)) {
h=h+2;
SIGc=(sigma^2)*IDc;
INVSIGc=invert(SIGc);

yic[0]=cd4[i+h];
yic[1]=cd4[i+(h+1)];
yic[2]=cd4[i+(h+2)];

predic[0]=pred[i+h];
predic[1]=pred[i+(h+1)];
predic[2]=pred[i+(h+2)];

zic[0]=x4[i+h];
zic[1]=x4[i+(h+1)];
zic[2]=x4[i+(h+2)];
zizic=zic*zic';
rc=yic-predic;

Stau2i[i]= (-(1/2)*sumr(diagonal(INVSIGc*zizic)))  +  ((1/2)*rc'*INVSIGc*zizic*INVSIGc*rc);
Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGc*IDc))) +  ((1/2)*rc'*INVSIGc*IDc*INVSIGc*rc);
Ks2s2i[i]=sumr(diagonal(INVSIGc*IDc))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2))) + (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*IDc*INVSIGc*IDc));
Kt2t2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*zizic))*(-1/4 + fgc/(3*(3+2)))   + (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*zizic));
Kt2s2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))  + (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*IDc));
}
}
Stau2=sumc(Stau2i);
Ssigma2=sumc(Ssigma2i);
Ks2s2 = sumc(Ks2s2i);
Kt2t2 = sumc(Kt2t2i);
Kt2s2 = sumc(Kt2s2i);
invKfifi=1/(Kt2t2 - Kt2s2*(1/Ks2s2)*Kt2s2);

z=Stau2 - Kt2s2*(1/Ks2s2)*Ssigma2;
//TS=z'*invKfifi*z;
//println("TS  (independence x random slope model)= ", TS);

mg = 2*invKfifi;
vg = -2*invKfifi*z;
ma = unit(columns(invKfifi));
vbs = zeros(columns(invKfifi),1);
[iret,x] = SolveQP(mg, vg, ma, vbs, <>, <>, <>, <>);

//funr=(x'mg*x) / 2 + vg'x +z'*invKfifi*z;
//TS1=z'*invKfifi*z-funr;
TS1=-(x'mg*x)/2 - vg'x;
println("TS1 (independence x random slope model) = ", TS1);

/*
#################################################################################
#######  Calculation of TS statistic for testing two random effect in the########
#######  intercept and/or slope against independence model               ########
#################################################################################
*/

yia=zeros(1,1) ;
predia=zeros(1,1);
zia=zeros(1,1);
SIGa=zeros(1,1);

yib=zeros(2,1);
predib=zeros(2,1);
zib=zeros(2,1);
SIGb=zeros(2,2);

yic=zeros(3,1);
predic=zeros(3,1);
zic=zeros(3,1);
SIGc=zeros(3,3);

Stau1i=zeros(39,1);
Stau2i=zeros(39,1);
Ssigma2i=zeros(39,1);
Ks2s2i=zeros(39,1);
Kt1t1i=zeros(39,1);
Kt2t2i=zeros(39,1);
Kt1s2i=zeros(39,1);
Kt2s2i=zeros(39,1);
Kt1t2i=zeros(39,1);
sigma=45.8839;
k=0;
h=17;
i=0;
	 

for (i=0;i<39;++i) {
if (i < 3) {
SIGa=sigma^2;
INVSIGa=invert(SIGa);

yia[0]=cd4[i];
predia[0]=pred[i];
zia[0]=x4[i];
zizia=zia*zia';
ra=yia-predia ;

Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGa*Ja)))   +  ((1/2)*ra'*INVSIGa*Ja*INVSIGa*ra);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGa*zizia))) +  ((1/2)*ra'*INVSIGa*zizia*INVSIGa*ra);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGa*IDa)))   +  ((1/2)*ra'*INVSIGa*IDa*INVSIGa*ra);

Ks2s2i[i]=sumr(diag(INVSIGa*IDa))*sumr(diag(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))    +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*IDa*INVSIGa*IDa)) ;

Kt1t1i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*Ja))*(-1/4 + fga/(1*(1+2)))      +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*Ja));

Kt2t2i[i]=sumr(diagonal(INVSIGa*zizia))*sumr(diagonal(INVSIGa*zizia))*(-1/4 + fga/(1*(1+2))) +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*zizia*INVSIGa*zizia));

Kt1s2i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))     +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*IDa));

Kt2s2i[i]=sumr(diagonal(INVSIGa*zizia))*sumr(diagonal(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))  +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*zizia*INVSIGa*IDa)) ;

Kt1t2i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*zizia))*(-1/4 + fga/(1*(1+2)))   +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*zizia));

}
else
if ((i>=3) && (i< 22)) {
SIGb=(sigma^2)*IDb;
INVSIGb=invert(SIGb);

yib[0]=cd4[i + k];
yib[1]=cd4[i + (k+1)];

predib[0]=pred[i + k];
predib[1]=pred[i + (k+1)];

zib[0]=x4[i + k];
zib[1]=x4[i + (k+1)];
zizib=zib*zib';
rb=yib-predib;

Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGb*Jb)))   +  ((1/2)*rb'*INVSIGb*Jb*INVSIGb*rb);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGb*zizib))) +  ((1/2)*rb'*INVSIGb*zizib*INVSIGb*rb);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGb*IDb)))   +  ((1/2)*rb'*INVSIGb*IDb*INVSIGb*rb);


Ks2s2i[i]=sumr(diagonal(INVSIGb*IDb))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))    +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*IDb*INVSIGb*IDb));

Kt1t1i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*Jb))*(-1/4 + fgb/(2*(2+2)))      +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*Jb));

Kt2t2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*zizib))*(-1/4 + fgb/(2*(2+2))) +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*zizib));

Kt1s2i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))     +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*IDb));

Kt2s2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))  +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*IDb));

Kt1t2i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*zizib))*(-1/4 + fgb/(2*(2+2)))   +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*zizib));
k=k+1;
}
else
if ((i>=22) && (i<=38)) {
h=h+2;
SIGc=(sigma^2)*IDc;
INVSIGc=invert(SIGc);

yic[0]=cd4[i+h];
yic[1]=cd4[i+(h+1)];
yic[2]=cd4[i+(h+2)];

predic[0]=pred[i+h];
predic[1]=pred[i+(h+1)];
predic[2]=pred[i+(h+2)];

zic[0]=x4[i+h];
zic[1]=x4[i+(h+1)];
zic[2]=x4[i+(h+2)];
zizic=zic*zic';
rc=yic-predic;
   
Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGc*Jc)))   +  ((1/2)*rc'*INVSIGc*Jc*INVSIGc*rc);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGc*zizic))) +  ((1/2)*rc'*INVSIGc*zizic*INVSIGc*rc);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGc*IDc)))   +  ((1/2)*rc'*INVSIGc*IDc*INVSIGc*rc);

Ks2s2i[i]=sumr(diagonal(INVSIGc*IDc))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))     +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*IDc*INVSIGc*IDc)) ;

Kt1t1i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*Jc))*(-1/4 + fgc/(3*(3+2)))       +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*Jc));

Kt2t2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*zizic))*(-1/4 + fgc/(3*(3+2))) +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*zizic));

Kt1s2i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))      +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*IDc));

Kt2s2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))   +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*IDc));

Kt1t2i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*zizic))*(-1/4 + fgc/(3*(3+2)))    +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*zizic)) ;

}
}
Stau1=sumc(Stau1i);
Stau2=sumc(Stau2i) ;
Ssigma2=sumc(Ssigma2i);
Ks2s2 = sumc(Ks2s2i);
Kt1t1 = sumc(Kt1t1i);
Kt2t2 = sumc(Kt2t2i);
Kt1s2=sumc(Kt1s2i);
Kt2s2 = sumc(Kt2s2i);
Kt1t2 = sumc(Kt1t2i);

z=zeros(2,1);
z[0]=Stau1 - Kt1s2*(1/Ks2s2)*Ssigma2;
z[1]=Stau2 - Kt2s2*(1/Ks2s2)*Ssigma2;

invKfifi= zeros(2,2) ;
invKfifi[0][0]=Kt1t1 - Kt1s2*(1/Ks2s2)*Kt1s2;
invKfifi[0][1]=Kt1t2 - Kt1s2*(1/Ks2s2)*Kt2s2	;
invKfifi[1][0]=Kt1t2 - Kt2s2*(1/Ks2s2)*Kt1s2	;
invKfifi[1][1]=Kt2t2 - Kt2s2*(1/Ks2s2)*Kt2s2	;

invKfifi= invert(invKfifi);

//TS=z'*invKfifi*z;
//println("TS  (independence x random intercept-slope model) = ", TS);

mg = 2*invKfifi;
vg = -2*invKfifi*z;
ma = unit(columns(invKfifi));
vbs = zeros(columns(invKfifi),1);
[iret,x] = SolveQP(mg, vg, ma, vbs, <>, <>, <>, <>);

//funr=(x'mg*x) / 2 + vg'x +z'*invKfifi*z;
//TS1=z'*invKfifi*z-funr;
TS1=-(x'mg*x)/2 - vg'x;
println("TS1 (independence x random intercept-slope model) = ", TS1);

/*
#################################################################################
#######  Calculation of TS statistic for testing two random effect in the########
#######  intercept and/or slope against the random slope model           ########
#################################################################################

######## The fitted values of the NORMAL random-slope model is in predNOrs.txt;
*/

mx = loadmat("C:/carine/doutorado/artigo_tese/exemplos/aids/programas_corrigidos/predNOrs.txt");
obse=mx[][0];
pacrep=mx[][1];
pac=mx[][2];
cd4=mx[][3];
x3=mx[][4];
x4=mx[][5];
pred1=mx[][6];
yia=zeros(1,1);
predia=zeros(1,1);
zia=zeros(1,1);
SIGa=zeros(1,1);

yib=zeros(2,1);
predib=zeros(2,1);
zib=zeros(2,1);
SIGb=zeros(2,2);

yic=zeros(3,1);
predic=zeros(3,1);
zic=zeros(3,1);
SIGc=zeros(3,3);

Stau1i=zeros(39,1);
Stau2i=zeros(39,1);
Ssigma2i=zeros(39,1);
Ks2s2i=zeros(39,1);
Kt1t1i=zeros(39,1);
Kt2t2i=zeros(39,1);
Kt1s2i=zeros(39,1);
Kt2s2i=zeros(39,1);
Kt1t2i=zeros(39,1);

sigma=23.92591;
tau2=0.2023038;
k=0;
h=17;
i=0;

for (i=0;i<39;++i){
if (i < 3) {
yia[0]=cd4[i];
predia[0]=pred1[i];
zia[0]=x4[i];
zizia=zia*zia';
ra=yia-predia;

SIGa=sigma^2 + tau2^2*zizia;
INVSIGa=invert(SIGa);

Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGa*Ja)))   +  ((1/2)*ra'*INVSIGa*Ja*INVSIGa*ra);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGa*zizia))) +  ((1/2)*ra'*INVSIGa*zizia*INVSIGa*ra);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGa*IDa)))   +  ((1/2)*ra'*INVSIGa*IDa*INVSIGa*ra);


Ks2s2i[i]=sumr(diagonal(INVSIGa*IDa))*sumr(diagonal(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))    +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*IDa*INVSIGa*IDa));

Kt1t1i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*Ja))*(-1/4 + fga/(1*(1+2)))      +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*Ja)) ;

Kt2t2i[i]=sumr(diagonal(INVSIGa*zizia))*sumr(diagonal(INVSIGa*zizia))*(-1/4 + fga/(1*(1+2))) +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*zizia*INVSIGa*zizia));

Kt1s2i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))     +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*IDa));

Kt2s2i[i]=sumr(diagonal(INVSIGa*zizia))*sumr(diagonal(INVSIGa*IDa))*(-1/4 + fga/(1*(1+2)))  +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*zizia*INVSIGa*IDa))	;

Kt1t2i[i]=sumr(diagonal(INVSIGa*Ja))*sumr(diagonal(INVSIGa*zizia))*(-1/4 + fga/(1*(1+2)))   +  (2*fga/(1*(1+2)))*sumr(diagonal(INVSIGa*Ja*INVSIGa*zizia));

}
else
if ((i>=3) && (i< 22)) {

yib[0]=cd4[i + k];
yib[1]=cd4[i + (k+1)];

predib[0]=pred1[i + k] ;
predib[1]=pred1[i + (k+1)];

zib[0]=x4[i + k];
zib[1]=x4[i + (k+1)] ;
zizib=zib*zib';
rb=yib-predib;

SIGb=(sigma^2)*IDb +(tau2^2)*zizib;
INVSIGb=invert(SIGb);

Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGb*Jb)))   +  ((1/2)*rb'*INVSIGb*Jb*INVSIGb*rb);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGb*zizib))) +  ((1/2)*rb'*INVSIGb*zizib*INVSIGb*rb);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGb*IDb)))   +  ((1/2)*rb'*INVSIGb*IDb*INVSIGb*rb);


Ks2s2i[i]=sumr(diagonal(INVSIGb*IDb))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))    +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*IDb*INVSIGb*IDb));

Kt1t1i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*Jb))*(-1/4 + fgb/(2*(2+2)))      +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*Jb));

Kt2t2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*zizib))*(-1/4 + fgb/(2*(2+2))) +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*zizib));

Kt1s2i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))     +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*IDb));

Kt2s2i[i]=sumr(diagonal(INVSIGb*zizib))*sumr(diagonal(INVSIGb*IDb))*(-1/4 + fgb/(2*(2+2)))  +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*zizib*INVSIGb*IDb)) ;

Kt1t2i[i]=sumr(diagonal(INVSIGb*Jb))*sumr(diagonal(INVSIGb*zizib))*(-1/4 + fgb/(2*(2+2)))   +  (2*fgb/(2*(2+2)))*sumr(diagonal(INVSIGb*Jb*INVSIGb*zizib));
k=k+1;
}
else
if ((i>=22) && (i<=38 )) {
h=h+2 ;

yic[0]=cd4[i+h];
yic[1]=cd4[i+(h+1)];
yic[2]=cd4[i+(h+2)];

predic[0]=pred1[i+h] ;
predic[1]=pred1[i+(h+1)] ;
predic[2]=pred1[i+(h+2)] ;

zic[0]=x4[i+h];
zic[1]=x4[i+(h+1)];
zic[2]=x4[i+(h+2)];
zizic=zic*zic';
rc=yic-predic ;

SIGc=(sigma^2)*IDc +(tau2^2)*zizic	;
INVSIGc=invert(SIGc);

Stau1i[i]=  (-(1/2)*sumr(diagonal(INVSIGc*Jc)))   +  ((1/2)*rc'*INVSIGc*Jc*INVSIGc*rc);

Stau2i[i]=  (-(1/2)*sumr(diagonal(INVSIGc*zizic))) +  ((1/2)*rc'*INVSIGc*zizic*INVSIGc*rc);

Ssigma2i[i]=(-(1/2)*sumr(diagonal(INVSIGc*IDc)))   +  ((1/2)*rc'*INVSIGc*IDc*INVSIGc*rc);


Ks2s2i[i]=sumr(diagonal(INVSIGc*IDc))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))    +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*IDc*INVSIGc*IDc));

Kt1t1i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*Jc))*(-1/4 + fgc/(3*(3+2)))      +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*Jc)) ;

Kt2t2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*zizic))*(-1/4 + fgc/(3*(3+2))) +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*zizic)) ;

Kt1s2i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))     +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*IDc))	;

Kt2s2i[i]=sumr(diagonal(INVSIGc*zizic))*sumr(diagonal(INVSIGc*IDc))*(-1/4 + fgc/(3*(3+2)))  +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*zizic*INVSIGc*IDc));

Kt1t2i[i]=sumr(diagonal(INVSIGc*Jc))*sumr(diagonal(INVSIGc*zizic))*(-1/4 + fgc/(3*(3+2)))   +  (2*fgc/(3*(3+2)))*sumr(diagonal(INVSIGc*Jc*INVSIGc*zizic));

}
}

Stau1=sumc(Stau1i) ;
Stau2=sumc(Stau2i);
Ssigma2=sumc(Ssigma2i);
Ks2s2 = sumc(Ks2s2i);
Kt1t1 = sumc(Kt1t1i);
Kt2t2 = sumc(Kt2t2i);
Kt1s2=sumc(Kt1s2i);
Kt2s2 = sumc(Kt2s2i)	;
Kt1t2 = sumc(Kt1t2i)	;

E=Kt2t2 - Kt2s2*invert(Ks2s2)*Kt2s2	;
G=invert(Ks2s2)*Kt2s2;

A=invert(Ks2s2) - G*invert(E)*G';
B=-G*invert(E);
C=B';
D=invert(E);

z=(Stau1 - (Kt1s2*A + Kt1t2*C)*Ssigma2 - (Kt1s2*B + Kt1t2*D)*Stau2)	;

invKfifi=1/( Kt1t1 - Kt1s2*(Kt1s2*A + Kt1t2*C) - Kt1t2*(Kt1s2*B + Kt1t2*D))	;

//TS=z'*invKfifi*z ;
//println("TS =  (random slope model x random intercept-slope model)", TS);

mg = 2*invKfifi;
vg = -2*invKfifi*z;
ma = unit(columns(invKfifi));
vbs = zeros(columns(invKfifi),1);
[iret,x] = SolveQP(mg, vg, ma, vbs, <>, <>, <>, <>);

//funr=(x'mg*x) / 2 + vg'x +z'*invKfifi*z;
//TS1=z'*invKfifi*z-funr;
TS1=-(x'mg*x)/2 - vg'x;
println("TS1 (random slope model x random intercept-slope model) = ", TS1);



}
